/*
Napisati funkcije koje ispisuju od kvadratne matrice:
        a) i-ti redak,
        b) j-ti stupac,
        c) glavnu dijagonalu,
        d) sporednu dijagonalu,
        e) tocke koje leze na pravcu paralelnom glavnoj dijagonali
        i prolaze tockom (a,b),
        f) tocke koje leze na pravcu paralelnom sporednoj dijagonali
        i prolaze tockom (a,b),
*/

#include <stdio.h>

void ispis_mat(double x[], int maxj, int n)
{
    int i, j;

    for(i=0; i<n; i++){
        for(j=0; j<n; j++){
            printf("%8.2f", x[maxj*i+j]);
        }
        printf("\n");
    }
}

//(a)
void ispis_redak(double x[], int maxj, int n, int i)
{
    int j;

    for(j=0; j<n; j++){
        printf("%g ", x[maxj*i+j]);
    }
}

//(d)
void ispis_sp_dijag(double x[], int maxj, int n)
{
    int i;

    for(i=0; i<n; i++){
        printf("%g ", x[maxj*i+n-1-i]); //j=n-1-i
    }
}

//(e)
void ispis_parl_gl_dijag(double x[], int maxj, int n, int a, int b)
{
    int i;

    for(i=0; i<n; i++){
        if(i-a+b>=0 && i-a+b<=n-1){
            printf("%g ", x[maxj*i+i-a+b]); //j=i-a+b
        }
    }
}

//(f)
void ispis_parl_sp_dijag(double x[], int maxj, int n, int a, int b)
{
    int i;

    for(i=0; i<n; i++){
        if(a+b-i>=0 && a+b-i<=n-1){
            printf("%g ", x[maxj*i+a+b-i]); //j=a+b-i
        }
    }
}

//zad.3.1.5
double produkt_sp_dijag(double x[], int maxj, int n)
{
    int i;
    double p=1;

    for(i=0; i<n; i++){
        p*=x[maxj*i+n-1-i]; //j=n-1-i
    }

    return p;
}

int main(void)
{
    double a[][3]={{1,2,3},{4,5,6},{7,8,9}};
    int n;

    n=sizeof(a)/sizeof(*a);

    ispis_mat(a,3,n);
    printf("\n\n");
    ispis_redak((double*)a,3,n,1);
    printf("\n");
    ispis_sp_dijag((double*)a,3,n);
    printf("\n");
    ispis_parl_gl_dijag((double*)a,3,n,1,0);
    printf("\n");
    ispis_parl_sp_dijag((double*)a,3,n,1,0);
    printf("\n");
    printf("Produkt je %g\n", produkt_sp_dijag((double*)a,3,n));

    return 0;
}
